package ch.std.jumpstart.rest;

import java.util.List;

import org.modelmapper.ModelMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import ch.std.jumpstart.dto.CityDTO;
import ch.std.jumpstart.jpa.City;
import ch.std.jumpstart.service.CityServiceCached;
import ch.std.jumpstart.service.CityServiceCached.CacheManagerDTO;

@RestController
@RequestMapping("/rest/auto/cache")
public class CityCachedAutoCompleteController {
	
	@Autowired
	private CityServiceCached cityServiceCached;
	
	@Autowired
	private ModelMapper modelMapper;

	@GetMapping("/cities")
	public CityDTO[] autoComplete(@RequestParam(value = "value") String value) {
		List<City> cities = (List<City>) this.cityServiceCached.find(value);
		return cities.stream().map(city -> convertToDTO(city)).toArray(CityDTO[]::new);
	}
	
	@GetMapping("/add")
	public void addCity(@RequestParam(value = "value") String value) {
		this.cityServiceCached.add(value);
	}

	@GetMapping("/manager")
	public CacheManagerDTO getCacheManager() {
		return this.cityServiceCached.getCacheManager();
	}

	private CityDTO convertToDTO(City city) {
		return this.modelMapper.map(city, CityDTO.class);
	}
}
